Version:  2.0.40 2.2.26 2.4.37 3.13 3.14 3.15 3.16 3.17 3.18 3.19 4.0 4.1 4.2 4.3 4.4 4.5 4.6 4.7 4.8 4.9 4.10

Linux/scripts/decodecode

  1 #!/bin/sh
  2 # Disassemble the Code: line in Linux oopses
  3 # usage: decodecode < oops.file
  4 #
  5 # options: set env. variable AFLAGS=options to pass options to "as";
  6 # e.g., to decode an i386 oops on an x86_64 system, use:
  7 # AFLAGS=--32 decodecode < 386.oops
  8 
  9 cleanup() {
 10         rm -f $T $T.s $T.o $T.oo $T.aa $T.dis
 11         exit 1
 12 }
 13 
 14 die() {
 15         echo "$@"
 16         exit 1
 17 }
 18 
 19 trap cleanup EXIT
 20 
 21 T=`mktemp` || die "cannot create temp file"
 22 code=
 23 
 24 while read i ; do
 25 
 26 case "$i" in
 27 *Code:*)
 28         code=$i
 29         ;;
 30 esac
 31 
 32 done
 33 
 34 if [ -z "$code" ]; then
 35         rm $T
 36         exit
 37 fi
 38 
 39 echo $code
 40 code=`echo $code | sed -e 's/.*Code: //'`
 41 
 42 width=`expr index "$code" ' '`
 43 width=$((($width-1)/2))
 44 case $width in
 45 1) type=byte ;;
 46 2) type=2byte ;;
 47 4) type=4byte ;;
 48 esac
 49 
 50 disas() {
 51         ${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1
 52 
 53         if [ "$ARCH" = "arm" ]; then
 54                 if [ $width -eq 2 ]; then
 55                         OBJDUMPFLAGS="-M force-thumb"
 56                 fi
 57 
 58                 ${CROSS_COMPILE}strip $1.o
 59         fi
 60 
 61         ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \
 62                 grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1
 63 }
 64 
 65 marker=`expr index "$code" "\<"`
 66 if [ $marker -eq 0 ]; then
 67         marker=`expr index "$code" "\("`
 68 fi
 69 
 70 touch $T.oo
 71 if [ $marker -ne 0 ]; then
 72         echo All code >> $T.oo
 73         echo ======== >> $T.oo
 74         beforemark=`echo "$code"`
 75         echo -n "       .$type 0x" > $T.s
 76         echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s
 77         disas $T
 78         cat $T.dis >> $T.oo
 79         rm -f $T.o $T.s $T.dis
 80 
 81 # and fix code at-and-after marker
 82         code=`echo "$code" | cut -c$((${marker} + 1))-`
 83 fi
 84 echo Code starting with the faulting instruction  > $T.aa
 85 echo =========================================== >> $T.aa
 86 code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'`
 87 echo -n "       .$type 0x" > $T.s
 88 echo $code >> $T.s
 89 disas $T
 90 cat $T.dis >> $T.aa
 91 
 92 # (lines of whole $T.oo) - (lines of $T.aa, i.e. "Code starting") + 3,
 93 # i.e. the title + the "===..=" line (sed is counting from 1, 0 address is
 94 # special)
 95 faultlinenum=$(( $(wc -l $T.oo  | cut -d" " -f1) - \
 96                  $(wc -l $T.aa  | cut -d" " -f1) + 3))
 97 
 98 faultline=`cat $T.dis | head -1 | cut -d":" -f2-`
 99 faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'`
100 
101 cat $T.oo | sed -e "${faultlinenum}s/^\(.*:\)\(.*\)/\1\*\2\t\t<-- trapping instruction/"
102 echo
103 cat $T.aa
104 cleanup

This page was automatically generated by LXR 0.3.1 (source).  •  Linux is a registered trademark of Linus Torvalds  •  Contact us